REM File: Program Deadcode for Sic v8.7a r8.1a

Rem Compile with VBdos1.0
Rem   BC Deadcode/ah/s/e/o;
Rem   LINK Deadcode,,,vbdos.lib/e;

' declare functions
FUNCTION Form$(Var#)
 Form$=Format$(Var#,"#,##0;;"+Chr$(34)+"zero"+Chr$(34))
END FUNCTION

ON ERROR GOTO Error.Routine

DIM subroutines(1 TO 1024) AS STRING
DIM variable(1 TO 1024) AS INTEGER
DIM subnames(1 TO 16) AS STRING

COLOR 15, 0
PRINT "Deadcode analyzer v1.3a for Sic."
COLOR 14, 0
PRINT "Press any key to start:";
LOCATE ,,1
WHILE INKEY$ = ""
WEND
PRINT

' locate files
flagtotals = False
Restore ProgramData
DO
   Read MainSub$, v
   If MainSub$="-eof-" Then
      Exit Do
   Endif
   If Dir$(MainSub$)="" Then
      flagtotals = true
      exit do
   Endif
Loop
If flagtotals Then
   count=0
   color 15,0
   Print "The following files were not found:"
   color 14,0
   Restore ProgramData
   DO
      Read MainSub$, v
      If MainSub$="-eof-" Then
         color 7,0
         if count>0 then
            Print
         endif
         End
      Endif
      If Dir$(MainSub$)="" Then
         Mid$(MainSub$,1,1)=Ucase$(Mid$(MainSub$,1,1))
         Print MainSub$;Space$(15-Len(MainSub$));
         count=count+1
         If count=5 Then
            Print
            count=0
         Endif
      Endif
   Loop
Endif

' get analyze type
looptype = False
COLOR 15, 0
PRINT "Enter analyze type: (1)prompt (2)continuous: ";
LOCATE ,,1
DO
   Var$ = ""
   WHILE Var$ = ""
      Var$ = INKEY$
   WEND
   IF Var$ = "1" THEN
      Print "1"
      looptype = 1
      EXIT DO
   END IF
   IF Var$ = "2" THEN
      Print "2"
      looptype = 2
      EXIT DO
   END IF
LOOP

' process filenames
flagtotals = False
Restore ProgramData
DO
   ' load sub names
   READ MainSub$, TotalSubs
   IF MainSub$ = "-eof-" THEN
      EXIT DO
   END IF
   subnames(1) = MainSub$
   subcount = subcount + 1
   FOR Var1 = 1 TO TotalSubs - 1
      READ MainSub$, y
      subnames(Var1 + 1) = MainSub$
      subcount = subcount + 1
   NEXT
   ' process subs
   routinecount = False
   FOR Var1 = 1 TO 1024
      subroutines(Var1) = ""
      variable(Var1) = False
   NEXT
   FOR Var1 = 1 TO TotalSubs
      programname$ = subnames(Var1)
      CLOSE
      OPEN programname$ FOR INPUT AS #1
      WHILE NOT EOF(1)
         LINE INPUT #1, programline$
         programline$ = LTRIM$(programline$)
         programline$ = LCASE$(programline$)
         IF LEFT$(programline$, 4) = "sub " THEN
            If Instr(ProgramLine$, "'") Then
               ProgramLine$ = RTRIM$(LEFT$(ProgramLine$, INSTR(ProgramLine$, "'") - 1))
            Endif
            programline$ = MID$(programline$, 5)
            programline$ = LTRIM$(programline$)
            IF INSTR(programline$, "(") THEN
               programline$ = LEFT$(programline$, INSTR(programline$, "(") - 1)
            END IF
            IF INSTR(programline$, "'") THEN
               programline$ = LEFT$(programline$, INSTR(programline$, "'") - 1)
            END IF
            programline$ = RTRIM$(programline$)
            lineexists = True
            IF routinecount > False THEN
               FOR arraycount = routinecount TO 1024
                  IF RTRIM$(subroutines(arraycount)) = "" THEN
                     EXIT FOR
                  END IF
                  IF RTRIM$(subroutines(arraycount)) = programline$ THEN
                     lineexists = False
                     EXIT FOR
                  END IF
               NEXT
            END IF
            IF lineexists THEN
               routinecount = routinecount + 1
               subroutines(routinecount) = programline$
            END IF
         END IF
      WEND
   NEXT
   COLOR 15, 0
   VarQ$ = Lcase$(subnames(1))
   VarQ$ = Left$(VarQ$,Instr(VarQ$,".")-1)
   Mid$(VarQ$,1,1) = Ucase$(Mid$(VarQ$,1,1))
   PRINT VarQ$; ": ";
   VarQ$ = Form$(Cdbl(routinecount)) + " unique subroutine"
   IF routinecount>1 Then
      VarQ$=VarQ$+"s"
   END IF
   VarQ$=VarQ$+"."
   PRINT VarQ$
   totalunique = totalunique + routinecount
   FOR Var1 = 1 TO TotalSubs
      programname$ = subnames(Var1)
      CLOSE
      OPEN programname$ FOR INPUT AS #1
      COLOR 14, 0
      PRINT UCASE$(programname$); " ";
      WHILE NOT EOF(1)
         LINE INPUT #1, programline$
         programline$ = LTRIM$(programline$)
         programline$ = LCASE$(programline$)
         If Instr(ProgramLine$, "'") Then
            ProgramLine$ = RTRIM$(LEFT$(ProgramLine$, INSTR(ProgramLine$, "'") - 1))
         Endif
         IF LEFT$(programline$, 5) = "call " THEN
            programline$ = MID$(programline$, 6)
            programline$ = LTRIM$(programline$)
            IF INSTR(programline$, "(") THEN
               programline$ = LEFT$(programline$, INSTR(programline$, "(") - 1)
            END IF
            IF INSTR(programline$, "'") THEN
               programline$ = LEFT$(programline$, INSTR(programline$, "'") - 1)
            END IF
            programline$ = RTRIM$(programline$)
            lineexists = False
            FOR arraycount = 1 TO routinecount
               IF RTRIM$(subroutines(arraycount)) = programline$ THEN
                  lineexists = True
                  EXIT FOR
               END IF
            NEXT
            IF lineexists THEN
               variable(arraycount) = variable(arraycount) + 1
            END IF
         END IF
      WEND
   NEXT
   PRINT
   flag = False
   FOR count = 1 TO routinecount
      IF variable(count) = False THEN
         COLOR 15, 0
         PRINT subroutines(count); " is deadcode."
         flag = True
         flagtotals = True
      END IF
   NEXT
   IF flag = False THEN
      COLOR 15, 0
      PRINT "No deadcode found."
   END IF
   IF INKEY$ = CHR$(27) THEN
      EXIT DO
   END IF
   IF flag = True OR looptype = 1 THEN
      COLOR 14, 0
      PRINT "More(y/n):";
      LOCATE ,,1
      DO
         Var$ = ""
         WHILE Var$ = ""
            Var$ = INKEY$
         WEND
         SELECT CASE LCASE$(Var$)
         CASE "n"
            COLOR 7, 0
            PRINT
            END
         CASE "y"
            PRINT
            EXIT DO
         CASE CHR$(13)
            PRINT
            EXIT DO
         CASE CHR$(32)
            PRINT
            EXIT DO
         END SELECT
      LOOP
   END IF
LOOP
IF flagtotals = False THEN
   COLOR 15, 0
   PRINT "No deadcode found in any subprograms."
END IF
COLOR 15, 0
PRINT "Total unique subroutines: ";
PRINT Form$(Cdbl(totalunique)); " in: ";
PRINT Form$(Cdbl(subcount)); " programs."
COLOR 7, 0
END

programdata:
Data "sic.bas",4
Data "sicsub1.bas",0
Data "sicsub2.bas",0
Data "sicsub3.bas",0

Data "analyze.bas",1
Data "indent.bas",1
Data "renumber.bas",1

DATA "-eof-",-1

Error.Routine:
PRINT "Error"; ERR; "file "; programname$
END
