 REM Sicsub3.bas v8.7a r8.1a - Symbolic Instruction Code; module 4 of 4.
 REM The public domain DOS programming interpreter.

 ' get standard include declarations
 REM $INCLUDE: 'SIC.INC'

SUB Name.Expression(Var)
 IF Var = 1 THEN
    Out2 = MID$(Out2, 7)
 ELSE
    Out2 = MID$(Out2, 5)
 END IF
 Out2 = STRIM$(Out2)
 Token.Index = 1
 CALL Get.Token
 CALL Parse1(Temp3#)
 IF Last.Token = False THEN
    Program.File$ = Out3
    IF Strng = "," Or Strng=";" THEN
       CALL Get.Token
       CALL Parse1(Temp4#)
       IF Last.Token = False THEN
	  NAME Program.File$ AS Out3
          EXIT SUB
       END IF
    END IF
 END IF
 ERROR 113
END SUB

SUB Kill.File(Var)
 IF Var = 1 THEN
    Out2 = MID$(Out2, 5)
 ELSE
    Out2 = MID$(Out2, 7)
 END IF
 Out2 = STRIM$(Out2)
 Token.Index = 1
 CALL Get.Token
 CALL Parse1(Temp3#)
 IF Last.Token = False THEN
    KILL Out3
    EXIT SUB
 END IF
 ERROR 114
END SUB

SUB CD.Directory(Var)
 IF Var = 1 THEN
    Out2 = MID$(Out2, 3)
 ELSE
    Out2 = MID$(Out2, 6)
 END IF
 Out2 = STRIM$(Out2)
 Token.Index = 1
 CALL Get.Token
 CALL Parse1(Temp3#)
 IF Last.Token = False THEN
    CHDIR Out3
    EXIT SUB
 END IF
 ERROR 115
END SUB

SUB MD.Directory(Var)
 IF Var = 1 THEN
    Out2 = MID$(Out2, 3)
 ELSE
    Out2 = MID$(Out2, 6)
 END IF
 Out2 = STRIM$(Out2)
 Token.Index = 1
 CALL Get.Token
 CALL Parse1(Temp3#)
 IF Last.Token = False THEN
    MKDIR Out3
    EXIT SUB
 END IF
 ERROR 116
END SUB

SUB RD.Directory(Var)
 IF Var = 1 THEN
    Out2 = MID$(Out2, 3)
 ELSE
    Out2 = MID$(Out2, 6)
 END IF
 Out2 = STRIM$(Out2)
 Token.Index = 1
 CALL Get.Token
 CALL Parse1(Temp3#)
 IF Last.Token = False THEN
    RMDIR Out3
    EXIT SUB
 END IF
 ERROR 117
END SUB

SUB Set.Date
 Out2 = MID$(Out2, 6)
 Out2 = STRIM$(Out2)
 IF LEFT$(Out2, 1) = "=" THEN
    Out2 = MID$(Out2, 2)
    Out2 = STRIM$(Out2)
    Token.Index = 1
    CALL Get.Token
    CALL Parse1(Temp3#)
    IF Last.Token = False THEN
       DATE$ = Out3
       EXIT SUB
    END IF
 END IF
 ERROR 118
END SUB

SUB Set.Time
 Out2 = MID$(Out2, 6)
 Out2 = STRIM$(Out2)
 IF LEFT$(Out2, 1) = "=" THEN
    Out2 = MID$(Out2, 2)
    Out2 = STRIM$(Out2)
    Token.Index = 1
    CALL Get.Token
    CALL Parse1(Temp3#)
    IF Last.Token = False THEN
       TIME$ = Out3
       EXIT SUB
    END IF
 END IF
 ERROR 119
END SUB

SUB Change.Drive
 Out2 = MID$(Out2, 8)
 Out2 = STRIM$(Out2)
 Token.Index = 1
 CALL Get.Token
 CALL Parse1(Temp3#)
 IF Last.Token = False THEN
    CHDRIVE Out3
    EXIT SUB
 END IF
 ERROR 120
END SUB

SUB Set.Environ
 Out2 = MID$(Out2, 8)
 Out2 = STRIM$(Out2)
 Token.Index = 1
 CALL Get.Token
 CALL Parse1(Temp3#)
 IF Last.Token = False THEN
    ENVIRON Out3
    EXIT SUB
 END IF
 ERROR 165
END SUB

SUB Swap.Data
 Temp1$ = MID$(Out2, 5)
 Temp1$ = STRIM$(Temp1$)
 Temp2$ = UCASE$(LEFT$(Temp1$, 1))
 IF Temp2$ >= "A" AND Temp2$ <= "Z" THEN
    Variable1 = ASC(Temp2$) - 64
    Temp1$ = MID$(Temp1$, 2)
    Temp1$ = STRIM$(Temp1$)
    IF LEFT$(Temp1$, 1) = "," Or Left$(Temp1$,1)=";" THEN
       Temp1$ = MID$(Temp1$, 2)
       Temp1$ = STRIM$(Temp1$)
       Temp2$ = UCASE$(LEFT$(Temp1$, 1))
       IF Temp2$ >= "A" AND Temp2$ <= "Z" THEN
	  Variable2 = ASC(Temp2$) - 64
	  Temp1$ = MID$(Temp1$, 2)
	  Temp1$ = STRIM$(Temp1$)
	  IF Temp1$ = Nul THEN
	     SWAP Variables(Variable1), Variables(Variable2)
             EXIT SUB
	  ELSE
             If Left$(Temp1$, 1) = "(" Or Left$(Temp1$, 1) = "[" Or Left$(Temp1$, 1) = "{" Then
                TokenLeft$ = Left$(Temp1$, 1)
		Out2 = MID$(Temp1$, 2)
		Out2 = STRIM$(Out2)
		Last.Token = False
		Token.Index = 1
		CALL Get.Token
		CALL Parse1(Temp3#)
                OK = 0
                If TokenLeft$ = "(" Then
                   If Strng = ")" Then
                      OK = -1
                   End If
                End If
                If TokenLeft$ = "[" Then
                   If Strng = "]" Then
                      OK = -1
                   End If
                End If
                If TokenLeft$ = "{" Then
                   If Strng = "}" Then
                      OK = -1
                   End If
                End If
                If OK = 0 Then
                   Error 110
                   Exit Sub
                End If
		Element = CINT(Temp3#)
                IF Element > False AND Element <= Max.Arrays THEN
                   SWAP Variables(Variable1), Arrays(Variable2, Element)
                   EXIT SUB
                END IF
	     END IF
	  END IF
       END IF
    ELSE
       If Left$(Temp1$, 1) = "(" Or Left$(Temp1$, 1) = "[" Or Left$(Temp1$, 1) = "{" Then
          TokenLeft$ = Left$(Temp1$, 1)
	  Out2 = MID$(Temp1$, 2)
	  Out2 = STRIM$(Out2)
	  Last.Token = False
	  Token.Index = 1
	  CALL Get.Token
	  CALL Parse1(Temp3#)
          OK = 0
          If TokenLeft$ = "(" Then
             If Strng = ")" Then
                OK = -1
             End If
          End If
          If TokenLeft$ = "[" Then
             If Strng = "]" Then
                OK = -1
             End If
          End If
          If TokenLeft$ = "{" Then
             If Strng = "}" Then
                OK = -1
             End If
          End If
          If OK = 0 Then
             Error 110
             Exit Sub
          End If
	  Element1 = CINT(Temp3#)
	  Temp1$ = MID$(Out2, Token.Index)
	  Temp1$ = STRIM$(Temp1$)
          IF LEFT$(Temp1$, 1) = "," Or Left$(Temp1$,1)=";" THEN
	     Out2 = MID$(Temp1$, 2)
	     Out2 = UCASE$(Out2)
	     Temp1$ = MID$(Temp1$, 2)
	     Temp1$ = STRIM$(Temp1$)
	     Temp2$ = UCASE$(LEFT$(Temp1$, 1))
	     IF Temp2$ >= "A" AND Temp2$ <= "Z" THEN
		Variable2 = ASC(Temp2$) - 64
		Temp1$ = MID$(Temp1$, 2)
		Temp1$ = STRIM$(Temp1$)
		IF Temp1$ = Nul THEN
                   IF Element1 > False AND Element1 <= Max.Arrays THEN
                      SWAP Arrays(Variable1, Element1), Variables(Variable2)
                      EXIT SUB
                   END IF
		ELSE
                   If Left$(Temp1$, 1) = "(" Or Left$(Temp1$, 1) = "[" Or Left$(Temp1$, 1) = "{" Then
                      TokenLeft$ = Left$(Temp1$, 1)
                      Out2 = MID$(Temp1$, 2)
		      Out2 = STRIM$(Out2)
		      Last.Token = False
		      Token.Index = 1
		      CALL Get.Token
		      CALL Parse1(Temp3#)
                      OK = 0
                      If TokenLeft$ = "(" Then
                         If Strng = ")" Then
                            OK = -1
                         End If
                      End If
                      If TokenLeft$ = "[" Then
                         If Strng = "]" Then
                            OK = -1
                         End If
                      End If
                      If TokenLeft$ = "{" Then
                         If Strng = "}" Then
                            OK = -1
                         End If
                      End If
                      If OK = 0 Then
                         Error 110
                         Exit Sub
                      End If
		      Element2 = CINT(Temp3#)
                      IF Element1 > False AND Element1 <= Max.Arrays THEN
                         IF Element2 > False AND Element2 <= Max.Arrays THEN
                            SWAP Arrays(Variable1, Element1), Arrays(Variable2, Element2)
                            EXIT SUB
                         END IF
                      END IF
		   END IF
		END IF
	     END IF
	  END IF
       ELSE
	  IF LEFT$(Temp1$, 1) = "$" THEN
	     Temp1$ = MID$(Temp1$, 2)
	     Temp1$ = STRIM$(Temp1$)
             IF LEFT$(Temp1$, 1) = "," Or Left$(Temp1$,1)=";" THEN
		Temp1$ = MID$(Temp1$, 2)
		Temp1$ = STRIM$(Temp1$)
		Temp2$ = UCASE$(LEFT$(Temp1$, 1))
		IF Temp2$ >= "A" AND Temp2$ <= "Z" THEN
		   Variable2 = ASC(Temp2$) - 64
		   Temp1$ = MID$(Temp1$, 2)
		   Temp1$ = STRIM$(Temp1$)
		   IF Temp1$ = "$" THEN
		      SWAP Strngs(Variable1), Strngs(Variable2)
                      EXIT SUB
		   END IF
		END IF
	     END IF
	  END IF
       END IF
    END IF
 END IF
 ERROR 110
END SUB

SUB Lock.File ' lock #
Out2 = MID$(Out2, 7)
Out2 = STRIM$(Out2)
Token.Index = 1
CALL Get.Token
CALL Parse1(Temp4#)
File.Num = CINT(Temp4#)
IF File.Num <= 0 OR File.Num > MaxFiles THEN
   ERROR 126
   EXIT SUB
END IF
If FileTraps(File.Num) Then
   ControlBreak = -2
   Exit Sub
End If
IF Strng = "," Or Strng = ";" THEN
   CALL Get.Token
   CALL Parse1(Temp4#)
   Filerec& = CLNG(Temp4#)
   IF Strng = "," Or Strng = ";" Or Strng = "TO" THEN
      CALL Get.Token
      CALL Parse1(Temp4#)
      Filerec2& = CLNG(Temp4#)
      LOCK File.Num, Filerec& TO Filerec2&
      For Z = 1 To RecordCount
         If FileRecords(Z) > 0& Then
            If FileRecords(Z) = Filerec& Then
               RecordNumber = Filerec&
               ControlBreak = -3
               Exit Sub
            End If
         End If
      Next
      For Z = 1 To RecordCount
         If FileRecords(Z) > 0& Then
            If FileRecords(Z) = Filerec2& Then
               RecordNumber = Filerec2&
               ControlBreak = -3
               Exit Sub
            End If
        End If
      Next
   ELSE
      LOCK File.Num, Filerec&
      For Z = 1 To RecordCount
         If FileRecords(Z) > 0& Then
            If FileRecords(Z) = Filerec& Then
               RecordNumber = Filerec&
               ControlBreak = -3
               Exit Sub
            End If
         End If
      Next
   END IF
   EXIT SUB
END IF
LOCK File.Num
END SUB

SUB Unlock.File ' unlock #
Out2 = MID$(Out2, 9)
Out2 = STRIM$(Out2)
Token.Index = 1
CALL Get.Token
CALL Parse1(Temp4#)
File.Num = CINT(Temp4#)
IF File.Num <= 0 OR File.Num > MaxFiles THEN
   ERROR 126
   EXIT SUB
END IF
If FileTraps(File.Num) Then
   ControlBreak = -2
   Exit Sub
End If
IF Strng = "," Or Strng = ";" THEN
   CALL Get.Token
   CALL Parse1(Temp4#)
   Filerec& = CLNG(Temp4#)
   IF Strng = "," Or Strng = ";" Or Strng = "TO" THEN
      CALL Get.Token
      CALL Parse1(Temp4#)
      Filerec2& = CLNG(Temp4#)
      UNLOCK File.Num, Filerec& TO Filerec2&
      For Z = 1 To RecordCount
         If FileRecords(Z) > 0& Then
            If FileRecords(Z) = Filerec& Then
               RecordNumber = Filerec&
               ControlBreak = -3
               Exit Sub
            End If
         End If
      Next
      For Z = 1 To RecordCount
         If FileRecords(Z) > 0& Then
            If FileRecords(Z) = Filerec2& Then
               RecordNumber = Filerec2&
               ControlBreak = -3
               Exit Sub
            End If
         End If
      Next
   ELSE
      UNLOCK File.Num, Filerec&
      For Z = 1 To RecordCount
         If FileRecords(Z) > 0& Then
            If FileRecords(Z) = Filerec& Then
               RecordNumber = Filerec&
               ControlBreak = -3
               Exit Sub
            End If
         End If
      Next
   END IF
   EXIT SUB
END IF
UNLOCK File.Num
END SUB

SUB Sleep.Second
 Out2 = MID$(Out2, 6)
 Out2 = STRIM$(Out2)
 IF LEN(Out2) = False THEN
    Temp3# = 1#
 ELSE
    Token.Index = 1
    CALL Get.Token
    CALL Parse1(Temp3#)
 END IF
 SLEEP CSNG(Temp3#)
END SUB

SUB Pause.Second
 Out2 = MID$(Out2, 6)
 Out2 = STRIM$(Out2)
 IF LEN(Out2) = False THEN
    Temp3# = 1#
 ELSE
    Token.Index = 1
    CALL Get.Token
    CALL Parse1(Temp3#)
 END IF
 Pause.Time! = CSNG(Temp3#)
 Time.Now! = TIMER
 DO
    ' calculate time elapsed
    Elapsed.Time! = TIMER - Time.Now!
    ' adjust for midnight
    IF Elapsed.Time! < 0! THEN
       Elapsed.Time! = Elapsed.Time! + 86400!
    END IF
    ' compare time elapsed
    IF Elapsed.Time! > Pause.Time! THEN
       EXIT DO
    END IF
 LOOP
END SUB

SUB Output.Port
 Out2 = MID$(Out2, 4)
 Out2 = STRIM$(Out2)
 Token.Index = 1
 CALL Get.Token
 CALL Parse1(Temp4#)
 Port.Address = CINT(Temp4#)
 IF Strng = "," Or Strng = ";" THEN
    CALL Get.Token
    CALL Parse1(Temp4#)
    Port.Byte = CINT(Temp4#)
    OUT Port.Address, Port.Byte
    EXIT SUB
 END IF
 ERROR 121
END SUB

SUB Wait.Port
 Allow.Extra = True
 Out2 = MID$(Out2, 5)
 Out2 = STRIM$(Out2)
 IF LEN(Out2) THEN
    Token.Index = 1
    CALL Get.Token
    CALL Parse1(Temp4#)
    Port.Address = CINT(Temp4#)
    IF Strng = "," Or Strng = ";" THEN
       CALL Get.Token
       CALL Parse1(Temp4#)
       And.Value = CINT(Temp4#)
       Xor.Value = False
       IF Strng = "," Or Strng = ";" THEN
	  CALL Get.Token
	  CALL Parse1(Temp4#)
	  Xor.Value = CINT(Temp4#)
       END IF
       WAIT Port.Address, And.Value, Xor.Value
       EXIT SUB
    END IF
 END IF
 ERROR 122
END SUB

SUB Int86.Function
 Out2 = MID$(Out2, 6)
 Out2 = STRIM$(Out2)
 Token.Index = 1
 CALL Get.Token3
 CALL Get.Token
 CALL Parse1(Temp4#)
 CALL Get.Token4
 Int86.Value = CINT(Temp4#)
 IF Int86.Value >= 0 AND Int86.Value <= 255 THEN
    InregsX.AX = INT(VAL("&H" + HEX$(AX)))
    InregsX.BX = INT(VAL("&H" + HEX$(BX)))
    InregsX.CX = INT(VAL("&H" + HEX$(CX)))
    InregsX.DX = INT(VAL("&H" + HEX$(DX)))
    InregsX.BP = INT(VAL("&H" + HEX$(BP)))
    InregsX.SI = INT(VAL("&H" + HEX$(SI)))
    InregsX.DI = INT(VAL("&H" + HEX$(DI)))
    InregsX.Flags = INT(VAL("&H" + HEX$(FL)))
    InregsX.DS = INT(VAL("&H" + HEX$(DS)))
    InregsX.ES = INT(VAL("&H" + HEX$(ES)))
    CALL InterruptX(Int86.Value, InregsX, OutregsX)
    IF OutregsX.AX < False THEN
       AX = CDBL(OutregsX.AX + 65536)
    ELSE
       AX = CDBL(OutregsX.AX)
    END IF
    IF OutregsX.BX < False THEN
       BX = CDBL(OutregsX.BX + 65536)
    ELSE
       BX = CDBL(OutregsX.BX)
    END IF
    IF OutregsX.CX < False THEN
       CX = CDBL(OutregsX.CX + 65536)
    ELSE
       CX = CDBL(OutregsX.CX)
    END IF
    IF OutregsX.DX < False THEN
       DX = CDBL(OutregsX.DX + 65536)
    ELSE
       DX = CDBL(OutregsX.DX)
    END IF
    IF OutregsX.BP < False THEN
       BP = CDBL(OutregsX.BP + 65536)
    ELSE
       BP = CDBL(OutregsX.BP)
    END IF
    IF OutregsX.SI < False THEN
       SI = CDBL(OutregsX.SI + 65536)
    ELSE
       SI = CDBL(OutregsX.SI)
    END IF
    IF OutregsX.DI < False THEN
       DI = CDBL(OutregsX.DI + 65536)
    ELSE
       DI = CDBL(OutregsX.DI)
    END IF
    IF OutregsX.Flags < False THEN
       FL = CDBL(OutregsX.Flags + 65536)
    ELSE
       FL = CDBL(OutregsX.Flags)
    END IF
    IF OutregsX.DS < False THEN
       DS = CDBL(OutregsX.DS + 65536)
    ELSE
       DS = CDBL(OutregsX.DS)
    END IF
    IF OutregsX.ES < False THEN
       ES = CDBL(OutregsX.ES + 65536)
    ELSE
       ES = CDBL(OutregsX.ES)
    END IF
 ELSE
    ERROR 158
 END IF
END SUB

SUB Defseg.Function
 Out2 = MID$(Out2, 7)
 Out2 = STRIM$(Out2)
 IF LEN(Out2) = False THEN
    DEF SEG ' restore segment
    InDEFSEG = False ' reset segment flag
    EXIT SUB
 END IF
 Token.Index = 1
 CALL Get.Token3
 CALL Get.Token
 CALL Parse1(Temp4#)
 CALL Get.Token4
 IF Temp4#>=0# AND Temp4#<=65535# THEN
    DEF SEG = Temp4# ' set segment
    InDEFSEG = True ' set segment flag
    DEFSEGvalue = Temp4# ' store segment value
    EXIT SUB
 END IF
 ERROR 125
END SUB

SUB Absolute.Function
 Out2 = MID$(Out2, 9)
 Out2 = STRIM$(Out2)
 IF LEN(Out2) THEN
    Token.Index = 1
    CALL Get.Token3
    CALL Get.Token
    CALL Parse1(Temp4#)
    CALL Get.Token4
    CALL Absolute(CINT(Temp4#))
    EXIT SUB
 END IF
 ERROR 123
END SUB

SUB Poke.Value
 Out2 = MID$(Out2, 5)
 Out2 = STRIM$(Out2)
 Token.Index = 1
 CALL Get.Token
 CALL Parse1(Temp4#)
 Poke.Address = CINT(Temp4#)
 IF Strng = "," Or Strng = ";" THEN
    CALL Get.Token
    CALL Parse1(Temp4#)
    Poke.Byte = CINT(Temp4#)
    POKE Poke.Address, Poke.Byte
    EXIT SUB
 END IF
 ERROR 124
END SUB

SUB Seed.Random
 Out2 = MID$(Out2, 10)
 Out2 = STRIM$(Out2)
 Token.Index = 1
 CALL Get.Token
 CALL Parse1(Temp3#)
 RANDOMIZE CLNG(Temp3#)
END SUB

 ' def fn(x)=value
SUB Define.Function
 Out2 = MID$(Out2, 7)
 Out2 = STRIM$(Out2)
 Token.Index = 1
 CALL Get.Token3
 CALL Get.Token
 CALL Parse1(Temp4#)
 CALL Get.Token4
 Func% = CINT(Temp4#)
 IF Func% >= 1 AND Func% <= Max.Functions THEN
    Out2 = MID$(Out2, Token.Index)
    Out2 = LTRIM$(Out2)
    IF LEFT$(Out2, 1) = "=" THEN
       Out2 = MID$(Out2, 2)
       Definitions(Func%) = Out2
       EXIT SUB
    END IF
 END IF
 ERROR 144
END SUB

